# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20200407

from .create_iceberg_catalog_details import CreateIcebergCatalogDetails
from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class CreateRestIcebergCatalogDetails(CreateIcebergCatalogDetails):
    """
    The information about a new Rest catalog used in the Iceberg connection.
    """

    def __init__(self, **kwargs):
        """
        Initializes a new CreateRestIcebergCatalogDetails object with values from keyword arguments. The default value of the :py:attr:`~oci.golden_gate.models.CreateRestIcebergCatalogDetails.catalog_type` attribute
        of this class is ``REST`` and it should not be changed.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param catalog_type:
            The value to assign to the catalog_type property of this CreateRestIcebergCatalogDetails.
            Allowed values for this property are: "GLUE", "HADOOP", "NESSIE", "POLARIS", "REST"
        :type catalog_type: str

        :param uri:
            The value to assign to the uri property of this CreateRestIcebergCatalogDetails.
        :type uri: str

        :param properties_secret_id:
            The value to assign to the properties_secret_id property of this CreateRestIcebergCatalogDetails.
        :type properties_secret_id: str

        """
        self.swagger_types = {
            'catalog_type': 'str',
            'uri': 'str',
            'properties_secret_id': 'str'
        }
        self.attribute_map = {
            'catalog_type': 'catalogType',
            'uri': 'uri',
            'properties_secret_id': 'propertiesSecretId'
        }
        self._catalog_type = None
        self._uri = None
        self._properties_secret_id = None
        self._catalog_type = 'REST'

    @property
    def uri(self):
        """
        **[Required]** Gets the uri of this CreateRestIcebergCatalogDetails.
        The base URL for the REST Catalog API.
        e.g.: 'https://my-rest-catalog.example.com/api/v1'


        :return: The uri of this CreateRestIcebergCatalogDetails.
        :rtype: str
        """
        return self._uri

    @uri.setter
    def uri(self, uri):
        """
        Sets the uri of this CreateRestIcebergCatalogDetails.
        The base URL for the REST Catalog API.
        e.g.: 'https://my-rest-catalog.example.com/api/v1'


        :param uri: The uri of this CreateRestIcebergCatalogDetails.
        :type: str
        """
        self._uri = uri

    @property
    def properties_secret_id(self):
        """
        **[Required]** Gets the properties_secret_id of this CreateRestIcebergCatalogDetails.
        The `OCID`__ of the Secret that stores the content
        of the configuration file containing additional properties for the REST catalog.
        See documentation: https://docs.oracle.com/en-us/iaas/Content/Identity/Tasks/managingcredentials.htm

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :return: The properties_secret_id of this CreateRestIcebergCatalogDetails.
        :rtype: str
        """
        return self._properties_secret_id

    @properties_secret_id.setter
    def properties_secret_id(self, properties_secret_id):
        """
        Sets the properties_secret_id of this CreateRestIcebergCatalogDetails.
        The `OCID`__ of the Secret that stores the content
        of the configuration file containing additional properties for the REST catalog.
        See documentation: https://docs.oracle.com/en-us/iaas/Content/Identity/Tasks/managingcredentials.htm

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :param properties_secret_id: The properties_secret_id of this CreateRestIcebergCatalogDetails.
        :type: str
        """
        self._properties_secret_id = properties_secret_id

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
