# coding: utf-8
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20241101


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class RestartWlsDomainDetails(object):
    """
    The configuration details for the restart WebLogic domain operation.
    """

    def __init__(self, **kwargs):
        """
        Initializes a new RestartWlsDomainDetails object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param is_force_servers_shutdown:
            The value to assign to the is_force_servers_shutdown property of this RestartWlsDomainDetails.
        :type is_force_servers_shutdown: bool

        """
        self.swagger_types = {
            'is_force_servers_shutdown': 'bool'
        }
        self.attribute_map = {
            'is_force_servers_shutdown': 'isForceServersShutdown'
        }
        self._is_force_servers_shutdown = None

    @property
    def is_force_servers_shutdown(self):
        """
        Gets the is_force_servers_shutdown of this RestartWlsDomainDetails.
        Force shutdown of the servers if they have not shutdown after a period of time. The timeout can be configured in the WebLogic domain configuration.


        :return: The is_force_servers_shutdown of this RestartWlsDomainDetails.
        :rtype: bool
        """
        return self._is_force_servers_shutdown

    @is_force_servers_shutdown.setter
    def is_force_servers_shutdown(self, is_force_servers_shutdown):
        """
        Sets the is_force_servers_shutdown of this RestartWlsDomainDetails.
        Force shutdown of the servers if they have not shutdown after a period of time. The timeout can be configured in the WebLogic domain configuration.


        :param is_force_servers_shutdown: The is_force_servers_shutdown of this RestartWlsDomainDetails.
        :type: bool
        """
        self._is_force_servers_shutdown = is_force_servers_shutdown

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
